/*! phoscon-app 2021-06-23 */

export const SW_CLASSID_MIN=3001;export const SW_CLASSID_MAX=3100;export const CLASSIDON=3001;export const CLASSIDOFF=3002;export const CLASSIDTOGGLEONOFF=3003;export const CLASSIDNEXTSCENE=3004;export const CLASSIDPREVSCENE=3005;export const CLASSIDCALLSCENE=3006;export const CLASSIDBRIUP=3007;export const CLASSIDBRIDOWN=3008;export const CLASSIDPUSHDIM=3009;export const CLASSIDPUSHDIMUP=3010;export const CLASSIDPUSHDIMDOWN=3011;export const CLASSIDBRIDIMUP=3012;export const CLASSIDBRIDIMDOWN=3013;export const CLASSIDCOLORLOOPSTART=3014;export const CLASSIDCOLORLOOPSTOP=3015;export const CLASSIDCOLORLOOPTOGGLE=3016;export const CLASSIDCTUP=3017;export const CLASSIDCTDOWN=3018;export const CLASSIDDIMCT=3019;export const CLASSIDDIMCTUP=3020;export const CLASSIDDIMCTDOWN=3021;export const CLASSIDCALLEFFECT=3022;export const CLASSIDNEXTEFFECT=3023;export const CLASSIDALLOFF=3024;export const ClassIds=[{options:[3001,3002,3003,3024],translateId:"func_onOffOptions",iconId:"#power-options-icon",class:"onoff-options"},{options:[3006,3004,3005],translateId:"func_callScene",iconId:"#scenes-icon",class:"callscene-options"},{options:[3007,3008],translateId:"func_dimming",iconId:"#sun-icon",class:"dimm-options"},{options:[3009,3010,3011],translateId:"func_dimming",iconId:"#sun-icon",class:"pushdimm-options"},{options:[3016,3022,3023],translateId:"func_effect",iconId:"#effect-icon",class:"effect-options"},{options:[3017,3018],translateId:"func_colorTemp",iconId:"#temperature-icon",class:"ct-options"},{options:[3019,3020,3021],translateId:"func_colorTemp",iconId:"#temperature-icon",class:"ct-push-options"}];export const rlFunctionMap=[{templ:"onOffOptions-item-template",class:"onoff-options"},{templ:"callScene-item-template",class:"callscene-options"},{templ:"dimm-item-template",class:"dimm-options"},{templ:"pushdimm-item-template",class:"pushdimm-options"},{templ:"effect-item-template",class:"effect-options"},{templ:"lightChain-item-template",class:"lightChain-options"},{templ:"ct-item-template",class:"ct-options"},{templ:"ct-push-item-template",class:"ct-push-options"}];export const classIdFunctionMap={3001:"on",3002:"off",3003:"toggleOnOff",3024:"allOff",3006:"callScene",3004:"nextScene",3005:"prevScene",3007:"briUp",3008:"briDown",3012:"briDimUp",3008:"briDimDown",3009:"pushDim",3010:"pushDimUp",3011:"pushDimDown",3016:"toggleColorLoop",3022:"callEffect",3023:"nextEffect",3017:"ctUp",3018:"ctDown",3019:"dimCt",3020:"dimCtUp",3021:"dimCtDown"};export const Events={SW_PRESSED:"SW_PRESSED",RL_PRESSED:"RL_PRESSED",FUNC_PRESSED:"FUNC_PRESSED",MENU_BTN_PRESSED:"MENUN_BTN_PRESSED",BTN_BACK_MAIN_PRESSED:"BTN_BACK_MAIN_PRESSED",BTN_ADD_SWITCH_PRESSED:"BTN_ADD_SWITCH_PRESSED",BTN_RENAME_SWITCH_PRESSED:"BTN_RENAME_SWITCH_PRESSED",BTN_DISMISS_PRESSED:"BTN_DISMISS_PRESSED",BTN_SAVE_PRESSED:"BTN_SAVE_PRESSED",BTN_CLOSE_PRESSED:"BTN_CLOSE_PRESSED"};export const States={IDLE:"IDLE",ACTIVESW:"ACTIVESW",ACTIVERL:"ACTIVERL"};export const getKeyByValue=(object,value)=>Object.keys(object).find(key=>object[key]===value);export const createResource=(gid,sid,clId,activeResource)=>new Promise((resolve,reject)=>{var button=getSwButton(activeResource),ruleValList=ruleFunctionMap[parseInt(clId)]||[],rsName=classIdFunctionMap[clId],rules=[],uid=app.switches.get(sid).get("uniqueid");if(!uid)return reject("missing uniqueid for api call");if(ruleValList.forEach(item=>{rules.push({name:item.name,conditions:[{address:"/sensors/"+uid+item.statekey,operator:"eq",value:button},{address:"/sensors/"+uid+"/state/lastupdated",operator:"dx"}],actions:[{address:"/groups/"+gid+"/action",body:item.action,method:"PUT"}]})}),0==rules.length)return reject("missing rules in function createRule");const rs={classid:parseInt(clId),description:"Resourcelink for switch rule",name:"opt_"+rsName,links:["/groups/"+gid,"/sensors/"+uid]};var p=[];rules.forEach(rule=>p.push(restCreateResource(app.rules,rule))),Promise.all(p).then(result=>{result.forEach(rid=>rs.links.push("/rules/"+rid)),restCreateResource(app.resourcelinks,rs).then(resolve).catch(reject)})});const ruleFunctionMap={3001:[{name:"Rule ON",statekey:"/state/buttonevent",action:{on:!0}}],3002:[{name:"Rule OFF",statekey:"/state/buttonevent",action:{on:!1}}],3003:[{statekey:"/state/buttonevent",action:{on:!0}},{statekey:"/state/buttonevent",action:{on:!1}}],3024:[],3006:[],3004:[],3005:[],3007:[],3008:[],3012:[],3008:[],3009:[],3010:[],3011:[],3016:[],3022:[],3023:[],3017:[],3018:[],3019:[],3020:[],3021:[]};function getSwButton(rl){var rule=rl.get("links").filter(l=>-1!==l.indexOf("rules")).map(r=>r.split("/")[2]).map(rid=>app.rules.get(rid))[0].get("conditions").find(c=>-1!==c.address.indexOf("buttonevent"));return rule?rule.value:void 0}export const deleteResource=rl=>{let toDelete=[],promises=[];promises.push(function checkResourcelink(rl){return new Promise((resolve,reject)=>{if(!rl)return reject();let links=rl.get("links")||[],sensors=links.filter(x=>-1!==x.indexOf("sensor")),rules=links.filter(x=>-1!==x.indexOf("rule"));return links.filter(x=>-1!==x.indexOf("resourcelink")).map(x=>app.resourcelinks.get(x.split("/")[2]||-1)).forEach(y=>promises.push(checkResourcelink(app.resourcelinks.get(y))||null)),sensors.map(x=>app.sensors.get(x.split("/")[2]||-1)).filter(y=>y?-1!==y.get("type").indexOf("CLIP"):null).forEach(z=>z?toDelete.push(z):null),rules.map(x=>app.rules.get(x.split("/")[2]||-1)).forEach(y=>y?toDelete.push(y):null),toDelete.push(rl),resolve()})}(rl)),Promise.all(promises).then(()=>{deleteResources(toDelete).then(console.log).catch(console.error)}).catch(console.log)};function deleteResources(resources){return Promise.all(resources.map(r=>{if(!r)return;let name=r.get("name");return restDeleteResource(r).then(id=>console.log("%c Resource ("+id+") deleted: "+name,DELETE)).catch(err=>err)}))}